package rocks.zipcode.io.quiz3.arrays;

import java.util.Arrays;

/**
 * @author leon on 09/12/2018.
 */
public class TicTacToe {

    private String[][] board;

    public TicTacToe(String[][] board) {
        this.board = board;
    }

    public String[] getRow(Integer value) {
        return board[value];
    }

    public String[] getColumn(Integer value) {
        String[] output = new String[3];
        output[0] = board[0][value];
        output[1] = board[1][value];
        output[2] = board[2][value];
        return output;
    }

    public Boolean isRowHomogenous(Integer rowIndex) {
        if(board[rowIndex][0].equals(board[rowIndex][1]) && board[rowIndex][1].equals(board[rowIndex][2]))return true;
        return false;
    }

    public Boolean isColumnHomogeneous(Integer columnIndex) {
        if (board[0][columnIndex].equals(board[1][columnIndex]) && board[1][columnIndex].equals(board[2][columnIndex]))return true;
        return false;
    }

    public Boolean isDiagHomogeneous(){
        if((board[0][0].equals(board[1][1]) && board[1][1].equals(board[2][2])) || (board[0][2].equals(board[1][1]) && board[1][1].equals(board[2][0]))) return true;
        return false;
    }

    public String getWinner() {
        for(int i = 0; i < 4; i++) {
            if(isRowHomogenous(i)) return board[i][1];
            if(isColumnHomogeneous(i)) return board[1][i];
            if(isDiagHomogeneous())return board[1][1];
        }
        return null;
    }
}