package rocks.zipcode.io.quiz3.collections;

import rocks.zipcode.io.quiz3.objectorientation.enums.LabStatus;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

/**
 * @author leon on 10/12/2018.
 */
public class Student {

    private Map<Lab, LabStatus> map;

    public Student() {
        map = new HashMap<>();
    }

    public Student(Map<Lab, LabStatus> map) {
        this.map = map;
    }

    public void setLabStatus(Lab lab, LabStatus labStatus){
        if (map.containsKey(lab)) {
            lab.setLabStatus(labStatus);
        }else{
            throw new UnsupportedOperationException("Something Went Wrong");
        }
    }

    public void forkLab(Lab lab) {
        map.put(lab, LabStatus.PENDING);
    }

    public LabStatus getLabStatus(String labName) {
        for(Map.Entry<Lab, LabStatus> entry : map.entrySet()){
            Lab lab = entry.getKey();
            if(lab.getName().equals(labName)){
                return lab.getLabStatus();
            }
        }
        return null;
    }

    public String toString(){
        String output = "";
        for(Map.Entry<Lab, LabStatus> entry : map.entrySet()){
            Lab lab = entry.getKey();
            output += lab.getName() + " > " + lab.getLabStatus() + "\n";
        }
        return output.trim();
    }
}
